﻿using System;
using System.Text;
using System.Collections;
using Microsoft.Win32;

namespace Common
{
    public class Reg
    {
        private static int _firstNoidID;
        public Reg()
        {
            Reg._firstNoidID = 0;
        }
        public Reg(int firstNoidID)
        {
            Reg._firstNoidID = firstNoidID;
        }
        public bool SetStringValueKeyToEncodingBase64(string subkey, string key, string val)
        {
            bool result;
            try
            {
                RegistryKey registryKey;
                switch (Reg._firstNoidID)
                {
                    case 0:
                        registryKey = Registry.LocalMachine;
                        break;
                    case 1:
                        registryKey = Registry.CurrentUser;
                        break;
                    default:
                        registryKey = Registry.LocalMachine;
                        break;
                }
                RegistryKey registryKey2 = registryKey.OpenSubKey(subkey, true);
                if (registryKey2 == null)
                {
                    registryKey2 = registryKey.CreateSubKey(subkey);
                    if (registryKey2 == null)
                    {
                        result = false;
                        return result;
                    }
                }
                byte[] bytes = Encoding.GetEncoding("gb2312").GetBytes(val);
                val = Convert.ToBase64String(bytes, 0, bytes.Length);
                registryKey2.SetValue(key, val);
                registryKey2.Close();
                result = true;
            }
            catch
            {
                result = false;
            }
            return result;
        }
        public bool SetStringValueKey(string subkey, string key, string val)
        {
            bool result;
            try
            {
                RegistryKey registryKey;
                switch (Reg._firstNoidID)
                {
                    case 0:
                        registryKey = Registry.LocalMachine;
                        break;
                    case 1:
                        registryKey = Registry.CurrentUser;
                        break;
                    default:
                        registryKey = Registry.LocalMachine;
                        break;
                }
                RegistryKey registryKey2 = registryKey.OpenSubKey(subkey, true);
                if (registryKey2 == null)
                {
                    registryKey2 = registryKey.CreateSubKey(subkey);
                    if (registryKey2 == null)
                    {
                        result = false;
                        return result;
                    }
                }
                registryKey2.SetValue(key, val);
                registryKey2.Close();
                result = true;
            }
            catch
            {
                result = false;
            }
            return result;
        }
        public bool SetIntValueKey(string subkey, string key, int val)
        {
            bool result;
            try
            {
                RegistryKey registryKey;
                switch (Reg._firstNoidID)
                {
                    case 0:
                        registryKey = Registry.LocalMachine;
                        break;
                    case 1:
                        registryKey = Registry.CurrentUser;
                        break;
                    default:
                        registryKey = Registry.LocalMachine;
                        break;
                }
                RegistryKey registryKey2 = registryKey.OpenSubKey(subkey, true);
                if (registryKey2 == null)
                {
                    registryKey2 = registryKey.CreateSubKey(subkey);
                    if (registryKey2 == null)
                    {
                        result = false;
                        return result;
                    }
                }
                registryKey2.SetValue(key, val);
                registryKey2.Close();
                result = true;
            }
            catch
            {
                result = false;
            }
            return result;
        }
        public bool GetStringValueKey(string subkey, string key, ref string val, string def)
        {
            bool result;
            try
            {
                RegistryKey registryKey;
                switch (Reg._firstNoidID)
                {
                    case 0:
                        registryKey = Registry.LocalMachine;
                        break;
                    case 1:
                        registryKey = Registry.CurrentUser;
                        break;
                    default:
                        registryKey = Registry.LocalMachine;
                        break;
                }
                RegistryKey registryKey2 = registryKey.OpenSubKey(subkey, true);
                if (registryKey2 != null)
                {
                    val = (string)registryKey2.GetValue(key, "");
                    if (val == "")
                    {
                        val = def;
                    }
                    registryKey2.Close();
                    result = true;
                }
                else
                {
                    result = false;
                }
            }
            catch
            {
                result = false;
            }
            return result;
        }
        public bool GetIntValueKey(string subkey, string key, ref int val, int def)
        {
            bool result;
            try
            {
                RegistryKey registryKey;
                switch (Reg._firstNoidID)
                {
                    case 0:
                        registryKey = Registry.LocalMachine;
                        break;
                    case 1:
                        registryKey = Registry.CurrentUser;
                        break;
                    default:
                        registryKey = Registry.LocalMachine;
                        break;
                }
                RegistryKey registryKey2 = registryKey.OpenSubKey(subkey, true);
                if (registryKey2 != null)
                {
                    val = (int)registryKey2.GetValue(key, -1);
                    if (val == -1)
                    {
                        val = def;
                    }
                    registryKey2.Close();
                    result = true;
                }
                else
                {
                    result = false;
                }
            }
            catch
            {
                result = false;
            }
            return result;
        }
        public bool GetSubKeyValueNames(string subkey, ref ArrayList valList)
        {
            bool result;
            try
            {
                RegistryKey registryKey;
                switch (Reg._firstNoidID)
                {
                    case 0:
                        registryKey = Registry.LocalMachine;
                        break;
                    case 1:
                        registryKey = Registry.CurrentUser;
                        break;
                    default:
                        registryKey = Registry.LocalMachine;
                        break;
                }
                RegistryKey registryKey2 = registryKey.OpenSubKey(subkey, true);
                if (registryKey2 != null)
                {
                    string[] valueNames = registryKey2.GetValueNames();
                    for (int i = 0; i < valueNames.Length; i++)
                    {
                        valList.Add(valueNames[i]);
                    }
                    registryKey2.Close();
                    result = true;
                }
                else
                {
                    result = false;
                }
            }
            catch
            {
                result = false;
            }
            return result;
        }
        public bool GetSubKeyNames(string subkey, ref ArrayList valList)
        {
            bool result;
            try
            {
                RegistryKey registryKey;
                switch (Reg._firstNoidID)
                {
                    case 0:
                        registryKey = Registry.LocalMachine;
                        break;
                    case 1:
                        registryKey = Registry.CurrentUser;
                        break;
                    default:
                        registryKey = Registry.LocalMachine;
                        break;
                }
                RegistryKey registryKey2 = registryKey.OpenSubKey(subkey, true);
                if (registryKey2 != null)
                {
                    string[] subKeyNames = registryKey2.GetSubKeyNames();
                    for (int i = 0; i < subKeyNames.Length; i++)
                    {
                        valList.Add(subKeyNames[i]);
                    }
                    registryKey2.Close();
                    result = true;
                }
                else
                {
                    result = false;
                }
            }
            catch
            {
                result = false;
            }
            return result;
        }
        public bool DelValueKey(string subkey, string key)
        {
            bool result;
            try
            {
                RegistryKey registryKey;
                switch (Reg._firstNoidID)
                {
                    case 0:
                        registryKey = Registry.LocalMachine;
                        break;
                    case 1:
                        registryKey = Registry.CurrentUser;
                        break;
                    default:
                        registryKey = Registry.LocalMachine;
                        break;
                }
                RegistryKey registryKey2 = registryKey.OpenSubKey(subkey, true);
                if (registryKey2 != null)
                {
                    registryKey2.DeleteValue(key);
                    registryKey2.Close();
                    result = true;
                }
                else
                {
                    result = false;
                }
            }
            catch
            {
                result = false;
            }
            return result;
        }
    }
}
