﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using Common.PageHelper;

namespace DAL
{
    public class ArticleDAO
    {
        private int pageCount = 0;

        public int PageCount
        {
            get { return pageCount; }
            set { pageCount = value; }
        }

        protected virtual string GetHTML(string url)
        {
            HttpItem item = new HttpItem()
            {
                Method = "get",
                URL = url
            };
            HttpHelper http = new HttpHelper();
            HttpResult result = http.GetHtml(item);
            return result.Html;
        }

        public virtual List<Model.Article> Init(string url, int index)
        {
            string currentUrl = url.Replace("{index}", index.ToString());
            string html = GetHTML(currentUrl);
            return GetModel(html);
        }

        protected virtual List<Model.Article> GetModel(string html)
        {
            throw new System.NotImplementedException();
        }
    }
}
