﻿using System.ComponentModel;
using System.Text;
using System.Windows.Forms;
using Common.PageHelper;
using System.Text.RegularExpressions;

namespace 程序员
{
    public partial class frmViewCode : Form
    {
        public frmViewCode(string url, string comefrom)
        {
            InitializeComponent();
            webBrowser1.ScriptErrorsSuppressed = true;
            switch (comefrom)
            {
                case "CSDN":
                    GetCSDNArticleHTML(url);
                    break;
                case "博客园":
                    GetCnblogsArticleHTML(url);
                    break;
                case "ITEyeBlog":
                    GetITEyeBlogArticleHTML(url);
                    break;
            }
        }

        private void GetCnblogsArticleHTML(string url)
        {
            //"http://www.cnblogs.com/niuww/p/3155963.html",
            HttpItem item = new HttpItem()
            {
                Method = "get",
                URL = url
            };

            HttpHelper http = new HttpHelper();
            HttpResult result = http.GetHtml(item);
            string html = result.Html;

            string csspattern = "<link type=\"text/css\" rel=\"stylesheet\" href=\".*?\"/>";
            Regex regex = new Regex(csspattern, RegexOptions.IgnoreCase | RegexOptions.Compiled);

            string css = "";
            MatchCollection ms = regex.Matches(html);

            foreach (Match m in ms)
            {
                css += m.Value;
            }

            string titlepattern = "<title>(?<title>.*?)</title>";
            regex = new Regex(titlepattern, RegexOptions.IgnoreCase | RegexOptions.Compiled);
            string title = regex.Match(html).Groups["title"].Value;
            if (!string.IsNullOrEmpty(title))
            {
                this.Text = title;
                title = "<center><h2>" + title + "</h2></center>\r\n";
            }
            string pattern = @"<div id=""cnblogs_post_body""[^>]*>[\s\S]*?(((?'open'<div[^>]*>)[\s\S]*?)+((?'-open'</div>)[\s\S]*?)+)*(?(open)(?!))</div>";
            regex = new Regex(pattern, RegexOptions.IgnoreCase | RegexOptions.Compiled);
            string content = regex.Match(html).Value;

            StringBuilder sb = new System.Text.StringBuilder();
            sb.Append("<html><head>");
            sb.Append(css);
            sb.Append("</head><body>");
            sb.Append("<a href=" + url + " target='_top'>" + title + "</a>");
            sb.Append(content);
            sb.Append("</body></html>");
            webBrowser1.DocumentText = sb.ToString();
        }

        private void GetCSDNArticleHTML(string url)
        {
            //"http://bbs.csdn.net/topics/390404605",
            HttpItem item = new HttpItem()
            {
                Method = "get",
                URL = url
            };

            HttpHelper http = new HttpHelper();
            HttpResult result = http.GetHtml(item);
            string html = result.Html;
            //http://bbs.csdn.net/assets/main-981188381cc7ba5718d417641e3c2082.css
            string csspattern = "<link href=\"/(?<css>.*?)\" media=\"(screen|all)\" rel=\"stylesheet\" type=\"text/css\" />";
            Regex regex = new Regex(csspattern, RegexOptions.IgnoreCase | RegexOptions.Compiled);

            string css = "";
            MatchCollection ms = regex.Matches(html);

            foreach (Match m in ms)
            {
                //    <link href="+d+" rel="stylesheet" type="text/css" />
                css += "<link href=\"http://bbs.csdn.net/" + m.Groups["css"].Value + "\" rel=\"stylesheet\" type=\"text/css\" />\r\n";
            }

            string titlepattern = "<title>(?<title>.*?)</title>";
            regex = new Regex(titlepattern, RegexOptions.IgnoreCase | RegexOptions.Compiled);
            string title = regex.Match(html).Groups["title"].Value;
            if (!string.IsNullOrEmpty(title))
            {
                this.Text = title;
                title = "<center><h2>" + title + "</h2></center>\r\n";
            }
            string pattern = "<div\\s*class=\"post_body\"[^>]*>(((?<o>)<div[^>]*>|(?<-o>)</div>|(?:(?!</?div)[\\s\\S]))*)(?(o)(?!))</div>";
            regex = new Regex(pattern, RegexOptions.IgnoreCase | RegexOptions.Compiled);

            string content = regex.Match(html).Value;

            StringBuilder sb = new System.Text.StringBuilder();
            sb.Append("<html><head>");
            sb.Append(css);
            sb.Append("</head><body>");
            sb.Append("<a href=" + url + " target='_top'>" + title + "</a>");
            sb.Append(content);
            sb.Append("</body></html>");
            webBrowser1.DocumentText = sb.ToString();
        }

        private void GetITEyeBlogArticleHTML(string url)
        {
            //"http://zhejiangyinghui.iteye.com/blog/1821096",
            HttpItem item = new HttpItem()
            {
                Method = "get",
                URL = url
            };

            HttpHelper http = new HttpHelper();
            HttpResult result = http.GetHtml(item);
            string html = result.Html;

            string csspattern = "<link href=\"http.*?\" media=\"screen\" rel=\"stylesheet\" type=\"text/css\" />";
            Regex regex = new Regex(csspattern, RegexOptions.IgnoreCase | RegexOptions.Compiled);

            string css = "";
            MatchCollection ms = regex.Matches(html);

            foreach (Match m in ms)
            {
                css += m.Groups["css"].Value;
            }

            string titlepattern = "<title>(?<title>.*?)</title>";
            regex = new Regex(titlepattern, RegexOptions.IgnoreCase | RegexOptions.Compiled);
            string title = regex.Match(html).Groups["title"].Value;
            if (!string.IsNullOrEmpty(title))
            {
                this.Text = title;
                title = "<center><h2>" + title + "</h2></center>\r\n";
            }
            string pattern = "<div\\s*class=\"blog_main\"[^>]*>(((?<o>)<div[^>]*>|(?<-o>)</div>|(?:(?!</?div)[\\s\\S]))*)(?(o)(?!))</div>";
            regex = new Regex(pattern, RegexOptions.IgnoreCase | RegexOptions.Compiled);

            string content = regex.Match(html).Value;

            StringBuilder sb = new System.Text.StringBuilder();
            sb.Append("<html><head>");
            sb.Append(css);
            sb.Append("</head><body>");
            sb.Append("<a href=" + url + " target='_top'>" + title + "</a>");
            sb.Append(content);
            sb.Append("</body></html>");
            webBrowser1.DocumentText = sb.ToString();
        }

        private void webBrowser1_NewWindow(object sender, CancelEventArgs e)
        {
            string url = ((System.Windows.Forms.WebBrowser)sender).StatusText;
            webBrowser1.Navigate(url);
            e.Cancel = true;
        }
    }
}
